
/*

ratio10 FILTER

author: reinhard@finalmedia.de
licence: public domain. no warranty.

cloning stdin to stdout,
while calculating ratio between upbits and downbits
and output result to stderr line by line.

you can visualize this later, e.g. by capturing stderr
to a .csv file

example usage: ratio10 < /dev/urandom > /dev/null 2> ergebnis.csv

*/

#include <stdio.h>

int main()
{

char c,i;
long int p=0;

while (1)
{

 c=getc(stdin);
 putc(c,stdout);

for (i=0; i < 8; i++) { if( (c << i) & 0x80 ) { p++; } else { p--; }}
fprintf(stderr,"%d\n",p);

}

return 0;

}
